searchNodes=[{"doc":"Azure Active Directory authentication using OpenID.","ref":"AzureADOpenId.html","title":"AzureADOpenId","type":"module"},{"doc":"Get a redirect url for authorization using Azure Active Directory login.","ref":"AzureADOpenId.html#authorize_url!/2","title":"AzureADOpenId.authorize_url!/2","type":"function"},{"doc":"Checks if the library is configured with the standard Elixir configuration (i.e. using the config files).","ref":"AzureADOpenId.html#configured?/0","title":"AzureADOpenId.configured?/0","type":"function"},{"doc":"Get an access token using the client credentials authorisation strategy for machine to machine authentication. Requires a client secret.","ref":"AzureADOpenId.html#get_access_token!/1","title":"AzureADOpenId.get_access_token!/1","type":"function"},{"doc":"Returns a human readable user name from an id_token/0 . This is useful as the Azure Active Directory id_token/0 can be very inconsistent in how user names are stored.","ref":"AzureADOpenId.html#get_user_name/1","title":"AzureADOpenId.get_user_name/1","type":"function"},{"doc":"Handles and validates the id_token/0 in the callback response. The redirect_uri used in the authorize_url!/1 function should redirect to a path that uses this funtion.","ref":"AzureADOpenId.html#handle_callback!/2","title":"AzureADOpenId.handle_callback!/2","type":"function"},{"doc":"Returns the redirect url for logging out of Azure Active Directory.","ref":"AzureADOpenId.html#logout_url/1","title":"AzureADOpenId.logout_url/1","type":"function"},{"doc":"Returns the redirect url for logging out of Azure Active Directory.","ref":"AzureADOpenId.html#logout_url/2","title":"AzureADOpenId.logout_url/2","type":"function"},{"doc":"Verify an access token.","ref":"AzureADOpenId.html#verify_access_token!/2","title":"AzureADOpenId.verify_access_token!/2","type":"function"},{"doc":"","ref":"AzureADOpenId.html#t:callback_response/0","title":"AzureADOpenId.callback_response/0","type":"type"},{"doc":"","ref":"AzureADOpenId.html#t:config/0","title":"AzureADOpenId.config/0","type":"type"},{"doc":"","ref":"AzureADOpenId.html#t:config_values/0","title":"AzureADOpenId.config_values/0","type":"type"},{"doc":"","ref":"AzureADOpenId.html#t:conn/0","title":"AzureADOpenId.conn/0","type":"type"},{"doc":"","ref":"AzureADOpenId.html#t:id_token/0","title":"AzureADOpenId.id_token/0","type":"type"},{"doc":"","ref":"AzureADOpenId.html#t:uri/0","title":"AzureADOpenId.uri/0","type":"type"},{"doc":"Helper functions for enforcing some conditions. The functions raise errors if the conditions aren't met. Useful for enforcing claims validation and destructuring :ok atoms without breaking the pipe.","ref":"AzureADOpenId.Enforce.html","title":"AzureADOpenId.Enforce","type":"module"},{"doc":"","ref":"AzureADOpenId.Enforce.html#ok!/2","title":"AzureADOpenId.Enforce.ok!/2","type":"function"},{"doc":"","ref":"AzureADOpenId.Enforce.html#true!/2","title":"AzureADOpenId.Enforce.true!/2","type":"function"},{"doc":"Creates, stores and checks nonces. A created nonce will be deleted after its timeout elapses.","ref":"AzureADOpenId.NonceStore.html","title":"AzureADOpenId.NonceStore","type":"module"},{"doc":"","ref":"AzureADOpenId.NonceStore.html#check_nonce/1","title":"AzureADOpenId.NonceStore.check_nonce/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"AzureADOpenId.NonceStore.html#child_spec/1","title":"AzureADOpenId.NonceStore.child_spec/1","type":"function"},{"doc":"","ref":"AzureADOpenId.NonceStore.html#create_nonce/1","title":"AzureADOpenId.NonceStore.create_nonce/1","type":"function"},{"doc":"","ref":"AzureADOpenId.NonceStore.html#start/2","title":"AzureADOpenId.NonceStore.start/2","type":"function"},{"doc":"","ref":"AzureADOpenId.NonceStore.html#start_link/1","title":"AzureADOpenId.NonceStore.start_link/1","type":"function"},{"doc":"Provides public key access for Azure Active directory Oauth. The public keys from the Microsoft openid configuration are fetched from the configuration endpoint. The appropriate key is selected using the x5t value from a token header.","ref":"AzureADOpenId.PublicKey.html","title":"AzureADOpenId.PublicKey","type":"module"},{"doc":"","ref":"AzureADOpenId.PublicKey.html#from_token/1","title":"AzureADOpenId.PublicKey.from_token/1","type":"function"},{"doc":"Oauth2 auth code strategy for Azure Active Directory.","ref":"AzureADOpenId.Strategy.AuthCode.html","title":"AzureADOpenId.Strategy.AuthCode","type":"module"},{"doc":"","ref":"AzureADOpenId.Strategy.AuthCode.html#authorize_url!/2","title":"AzureADOpenId.Strategy.AuthCode.authorize_url!/2","type":"function"},{"doc":"Oauth2 client credentials strategy for Azure Active Directory.","ref":"AzureADOpenId.Strategy.ClientCredentials.html","title":"AzureADOpenId.Strategy.ClientCredentials","type":"module"},{"doc":"","ref":"AzureADOpenId.Strategy.ClientCredentials.html#get_token!/1","title":"AzureADOpenId.Strategy.ClientCredentials.get_token!/1","type":"function"},{"doc":"Runs validation on the claims for decrypted tokens.","ref":"AzureADOpenId.Verify.Claims.html","title":"AzureADOpenId.Verify.Claims","type":"module"},{"doc":"","ref":"AzureADOpenId.Verify.Claims.html#access_token!/2","title":"AzureADOpenId.Verify.Claims.access_token!/2","type":"function"},{"doc":"","ref":"AzureADOpenId.Verify.Claims.html#code_hash!/2","title":"AzureADOpenId.Verify.Claims.code_hash!/2","type":"function"},{"doc":"","ref":"AzureADOpenId.Verify.Claims.html#common!/3","title":"AzureADOpenId.Verify.Claims.common!/3","type":"function"},{"doc":"","ref":"AzureADOpenId.Verify.Claims.html#id_token!/2","title":"AzureADOpenId.Verify.Claims.id_token!/2","type":"function"},{"doc":"Runs validation on the claims for Azure Active Directory claims.","ref":"AzureADOpenId.Verify.Token.html","title":"AzureADOpenId.Verify.Token","type":"module"},{"doc":"","ref":"AzureADOpenId.Verify.Token.html#access_token!/2","title":"AzureADOpenId.Verify.Token.access_token!/2","type":"function"},{"doc":"","ref":"AzureADOpenId.Verify.Token.html#id_token!/3","title":"AzureADOpenId.Verify.Token.id_token!/3","type":"function"},{"doc":"Azure Active Directory authentication using OpenID. This is a simple and opinionated OpenID authentication library for Azure Active Directory. The following decisions have been made: The nonce has a timeout of 15 minutes The callback will reject id_tokens with an iat that is more than 6 minutes old","ref":"readme.html","title":"Azure Active Directory OpenID","type":"extras"},{"doc":"The package can be installed by adding azure_ad_openid to your list of dependencies in mix.exs : def deps do [ { :azure_ad_openid , &quot;~&gt; 0.2&quot; } , ] end","ref":"readme.html#installation","title":"Azure Active Directory OpenID - Installation","type":"extras"},{"doc":"This library can be used with or without the standard Elixir configuration. If you want to use it with configuration set the following in your config files: config :azure_ad_openid , AzureADOpenId , tenant : &lt; your tenant &gt; , client_id : &lt; your client_id &gt; , client_secret : &lt;&gt; # only needed to generate access tokens If you don't setup the config, you will need to pass these values in manually at runtime. For example to get the authorization url: config = [ tenant : &lt; your tenant &gt; , client_id : &lt; your client_id &gt; ] AzureADOpenId . authorize_url! ( &lt; redirect_uri &gt; , config ) The following is a simple example of a Phoenix authentication controller that uses this library: defmodule MyAppWeb.AuthController do use MyAppWeb , :controller alias AzureADOpenId def login ( conn , _ ) do base_uri = Application . get_env ( :my_app , :base_uri ) redirect_uri = &quot; \#{ base_uri } /auth/callback&quot; redirect conn , external : AzureADOpenId . authorize_url! ( redirect_uri ) end def callback ( conn , _ ) do { :ok , claims } = AzureADOpenId . handle_callback! ( conn ) conn |&gt; put_session ( :user_claims , claims ) |&gt; redirect ( to : &quot;/&quot; ) end def logout ( conn , _ ) do conn |&gt; put_session ( :user_claims , nil ) |&gt; redirect ( external : AzureADOpenId . logout_url ( ) ) end end","ref":"readme.html#basic-usage","title":"Azure Active Directory OpenID - Basic Usage","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/azure_ad_openid .","ref":"readme.html#documentation","title":"Azure Active Directory OpenID - Documentation","type":"extras"},{"doc":"The following repository was used as a base for the AzureAD authentication: https://github.com/onurkucukkece/oauth_azure_activedirectory","ref":"readme.html#credit","title":"Azure Active Directory OpenID - Credit","type":"extras"},{"doc":"Please see LICENSE for licensing details.","ref":"readme.html#license","title":"Azure Active Directory OpenID - License","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2018 Tyson Buzza Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]